## aad-auth 0.5.2

=== vendor_rust/console/Makefile ===
all: test

check:
	@cargo check --all-features

build:
	@cargo build --all-features

doc:
	@cargo doc --all-features

test:
	@echo "CARGO TESTS"
	@cargo test
	@cargo test --all-features
	@cargo test --no-default-features

check-minver:
	@echo "MINVER CHECK"
	@cargo minimal-versions check
	@cargo minimal-versions check --all-features
	@cargo minimal-versions check --no-default-features

format:
	@rustup component add rustfmt 2> /dev/null
	@cargo fmt --all

format-check:
	@rustup component add rustfmt 2> /dev/null
	@cargo fmt --all -- --check

lint:
	@rustup component add clippy 2> /dev/null
	@cargo clippy --examples --tests

.PHONY: all doc build check test format format-check lint check-minver

=== vendor_rust/similar-asserts/Makefile ===
all: test

build:
	@cargo build --all-features

check:
	@cargo check --all-features
	@cargo check --all-features --examples

doc:
	@cargo doc --all-features

test: check
	@cargo test
	@cargo test --all-features
	@cargo test --no-default-features

test-141:
	@cargo test
	@cargo test --no-default-features

format:
	@rustup component add rustfmt 2> /dev/null
	@cargo fmt --all

format-check:
	@rustup component add rustfmt 2> /dev/null
	@cargo fmt --all -- --check

lint:
	@rustup component add clippy 2> /dev/null
	@cargo clippy

.PHONY: all doc test format format-check lint

## aad-auth 0.4

=== debian/changelog ===
aad-auth (0.4) lunar; urgency=medium

  * First upload to ubuntu
  * Rewrite NSS module in Rust: we can’t use Go to implicit use of threads
    which is incompatible with binaries linking against use and only using
    fork() without exec().

 -- Didier Roche <didrocks@ubuntu.com>  Tue, 21 Feb 2023 10:22:47 +0100

aad-auth (0.3) kinetic; urgency=medium

  [ Gabriel Nagy ]
  * Add aad-cli binary package (LP: #1989413)
    - this is a CLI that allows managing various aspects of the AAD
      integration, such as:
      - editing the configuration file in a safe way
      - querying cached users/groups attributes
      - updating cached user attributes (shell/homedir)
  * Update debian/copyright with the latest vendored dependencies

  [ Denison Barbosa ]
  * Improve consistency of offline credentials expiration
    - a negative value disables offline authentication, and 0 prevents
    the cache clean up process, allowing offline login for an
    undetermined amount of time

 -- Gabriel Nagy <gabriel.nagy@canonical.com>  Fri, 16 Sep 2022 15:37:40 +0300

aad-auth (0.2) kinetic; urgency=medium

  [ Didier Roche ]
  [ Denison Barbosa ]
  [ Gabriel Nagy ]
  [ Jean-Baptiste Lallement ]
  * Rewrite NSS Go library in C
    - due to random crashes caused by loading a multithreaded shared library
      written in Go from NSS, we now have a thin C wrapper calling a Go
      executable which does the actual queries
  * Add translations supported by gettext to the PAM module
    - to support the future CLI integration, these are shipped in a
      common architecture-independent package
  * Ship a configuration template in the common package
  * Fix segfault on interrupted pam conversation
  * Fix FTBFS on armhf due to int type size
  * Various test improvements and fixes
  * Update dependencies to latest:
    - github.com/AzureAD/microsoft-authentication-library-for-go
    - github.com/go-ini/ini
    - github.com/mattn/go-sqlite3

 -- Gabriel Nagy <gabriel.nagy@canonical.com>  Fri, 09 Sep 2022 10:48:17 +0300

aad-auth (0.1) kinetic; urgency=medium

  [ Didier Roche ]
  [ Denison Barbosa ]
  [ Gabriel Nagy ]
  * Initial release

 -- Gabriel Nagy <gabriel.nagy@canonical.com>  Wed, 24 Aug 2022 16:22:54 +0200

=== debian/control ===
Source: aad-auth
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 13),
               dh-apport,
               dh-cargo,
               dh-golang,
               golang-go (>= 2:1.18~),
               libpam0g-dev (>= 1.4),
               libc6-dev (>= 2.35),
               libglib2.0-dev (>= 2.72.1),
               pkg-config (>= 0.29.2),
               libsqlite3-dev (>= 3.37.2)
Standards-Version: 4.6.0.1
XS-Go-Import-Path: github.com/ubuntu/aad-auth
XS-Vendored-Sources-Rust: ahash@0.7.6, atty@0.2.14, autocfg@1.1.0, bitflags@1.3.2, bstr@0.2.17, cc@1.0.79, cfg-if@1.0.0, console@0.15.5, ctor@0.1.26, encode_unicode@0.3.6, error-chain@0.12.4, faccess@0.2.4, fallible-iterator@0.2.0, fallible-streaming-iterator@0.1.9, fastrand@1.8.0, getrandom@0.2.8, goldenfile@1.4.5, hashbrown@0.12.3, hashlink@0.8.1, hermit-abi@0.1.19, hostname@0.3.1, indexmap@1.9.2, instant@0.1.12, itoa@1.0.5, lazy_static@1.4.0, libc@0.2.139, libnss@0.4.0, libsqlite3-sys@0.25.2, log@0.4.17, match_cfg@0.1.0, memchr@2.5.0, num_threads@0.1.6, once_cell@1.17.0, paste-impl@0.1.18, paste@0.1.18, paste@1.0.11, pkg-config@0.3.26, proc-macro-error-attr@1.0.4, proc-macro-error@1.0.4, proc-macro-hack@0.5.20+deprecated, proc-macro2@1.0.51, quote@1.0.23, redox_syscall@0.2.16, regex-automata@0.1.10, remove_dir_all@0.5.3, rusqlite@0.28.0, ryu@1.0.12, serde@1.0.152, serde_derive@1.0.152, serde_yaml@0.9.17, similar-asserts@1.4.2, similar@2.2.1, simple_logger@4.0.0, smallvec@1.10.0, syn@1.0.107, syslog@6.0.1, tempfile@3.3.0, test-case-macros@2.2.2, test-case@2.2.2, time-core@0.1.0, time-macros@0.2.6, time@0.3.17, unicode-ident@1.0.6, unicode-segmentation@1.10.1, unsafe-libyaml@0.2.5, users@0.11.0, vcpkg@0.2.15, version_check@0.9.4, wasi@0.11.0+wasi-snapshot-preview1, winapi-i686-pc-windows-gnu@0.4.0, winapi-x86_64-pc-windows-gnu@0.4.0, winapi@0.3.9, windows-sys@0.42.0, windows_aarch64_gnullvm@0.42.1, windows_aarch64_msvc@0.42.1, windows_i686_gnu@0.42.1, windows_i686_msvc@0.42.1, windows_x86_64_gnu@0.42.1, windows_x86_64_gnullvm@0.42.1, windows_x86_64_msvc@0.42.1
Homepage: https://github.com/ubuntu/aad-auth
Description: Azure Active Directory Authentication
 Azure Active Directory Authentication enables authentication of Azure Active
 Directory accounts on your local system. It dynamically creates local accounts,
 supporting additional features like offline connectivity.


Package: libpam-aad
Architecture: any
Built-Using: ${misc:Built-Using},
Depends: aad-common,
         ${shlibs:Depends},
         ${misc:Depends},
Description: ${source:Synopsis} module for PAM
 ${source:Extended-Description}
 .
 This package contains the PAM module.

Package: libnss-aad
Architecture: any
Multi-Arch: same
Built-Using: ${misc:Built-Using},
Depends: aad-common,
         ${shlibs:Depends},
         ${misc:Depends},
Description: ${source:Synopsis} module for NSS
 ${source:Extended-Description}
 .
 This package contains the NSS module.

Package: aad-common
Architecture: all
Multi-Arch: foreign
Enhances: libpam-aad, libnss-aad, aad-cli
Depends: ${misc:Depends}
Description: ${source:Synopsis} common files
 ${source:Extended-Description}
 .
 This package contains configuration and translation files shared between the
 other AAD packages.

Package: aad-cli
Architecture: any
Built-Using: ${misc:Built-Using},
Depends: aad-common,
         ${shlibs:Depends},
         ${misc:Depends},
Description: ${source:Synopsis} CLI tool
 ${source:Extended-Description}
 .
 This package contains the CLI tool to manage various aspects of the Azure AD
 integration.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export GOCACHE := $(shell mktemp -d /tmp/gocache-XXXX)
export GOFLAGS := -ldflags=-X=github.com/ubuntu/aad-auth/internal/consts.Version=$(shell dpkg-parsechangelog -S Version) --mod=vendor -buildmode=pie

export DEB_BUILD_MAINT_OPTIONS := optimize=-lto

# Strict symbols checking
export DPKG_GENSYMBOLS_CHECK_LEVEL := 4

# Copy in build directory all content to embed
export DH_GOLANG_INSTALL_ALL := 1

# The following definitions are necessary because of the manual steps
# we need to do to work around some issues with either dh-cargo,
# the wrapper, or cargo
include /usr/share/rustc/architecture.mk
CARGO := /usr/share/cargo/bin/cargo

# Needed for Rust vendored sources tracking
DH_CARGO_VENDORED_SOURCES := /usr/share/cargo/bin/dh-cargo-vendored-sources
export CARGO_VENDOR_DIR = vendor_rust

%:
	dh $@ --buildsystem=golang --with=golang,apport

override_dh_auto_clean:
	dh_auto_clean
	dh_auto_clean --buildsystem=cargo

	# Create the vendor directory when building the source package
	[ -d vendor/ ] || go mod vendor

	# vcpkg has the same issue as system-deps, with .a files that are trimmed by dpkg-source.
	# so we need to replace the crate checksum to avoid build errors.
	if [ ! -d $(CARGO_VENDOR_DIR)/ ]; then \
		$(CARGO) vendor $(CARGO_VENDOR_DIR); \
		cp debian/cargo-checksum.json $(CARGO_VENDOR_DIR)/vcpkg/.cargo-checksum.json; \
		[ ! -e $(DH_CARGO_VENDORED_SOURCES) ] || $(DH_CARGO_VENDORED_SOURCES); \
	fi

override_dh_auto_configure:
	dh_auto_configure

	[ ! -e $(DH_CARGO_VENDORED_SOURCES) ] || $(DH_CARGO_VENDORED_SOURCES)
	DEB_HOST_GNU_TYPE=$(DEB_HOST_GNU_TYPE) DEB_HOST_RUST_TYPE=$(DEB_HOST_RUST_TYPE) \
		CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=nss_aad_$(shell dpkg-parsechangelog --show-field Version) \
		$(CARGO) prepare-debian $(CARGO_VENDOR_DIR)

	# By default, dh-cargo only replaces the crates-io source, which means we have to replace the git source manually
	cat debian/cargo-config-patch >> $(CURDIR)/debian/cargo_home/config

override_dh_auto_build:
	# Build PAM library
	go build -ldflags='-extldflags -Wl,-soname,pam_aad.so' -buildmode=c-shared -o pam_aad.so ./pam

	# Build the NSS library
	DEB_HOST_GNU_TYPE=$(DEB_HOST_GNU_TYPE) \
	DEB_HOST_RUST_TYPE=$(DEB_HOST_RUST_TYPE) \
	CARGO_HOME=$(CURDIR)/debian/cargo_home \
	$(CARGO) build --release

	# Build the CLI
	DH_GOLANG_BUILDPKG=github.com/ubuntu/aad-auth/cmd/aad-cli dh_auto_build

override_dh_auto_test:
	dh_auto_test --buildsystem=cargo -- test --all

	# We need to specify these Rust related variables to the Go tests in order to build the NSS lib
	# with the cargo wrapper in the integration tests in order to force cargo to use vendored deps
	# instead of querying crates.io for them.
	DEB_HOST_GNU_TYPE=$(DEB_HOST_GNU_TYPE) \
	DEB_HOST_RUST_TYPE=$(DEB_HOST_RUST_TYPE) \
	CARGO_HOME=$(CURDIR)/debian/cargo_home \
	CARGO_PATH=$(CARGO) \
	dh_auto_test

override_dh_auto_install:
	dh_auto_install -- --no-source

	# Install PAM module configuration
	mkdir -p debian/tmp/usr/share/pam-configs
	cp debian/libpam-aad.pam-auth-update debian/tmp/usr/share/pam-configs/aad

	# Install configuration template to /etc
	mkdir -p debian/tmp/etc
	cp conf/aad.conf.template debian/tmp/etc/aad.conf

	# Install PAM
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE)/security
	cp pam_aad.so debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE)/security

	# Install NSS
	install -dm 0755 debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE)
	cp target/$(DEB_HOST_RUST_TYPE)/release/libnss_aad.so target/$(DEB_HOST_RUST_TYPE)/release/libnss_aad.so.2
	install -m 0644 target/$(DEB_HOST_RUST_TYPE)/release/libnss_aad.so.2 debian/tmp/usr/lib/$(DEB_HOST_GNU_TYPE)


	# Generate and install translations and shell completions
	GENERATE_ONLY_INSTALL_TO_DESTDIR=$(CURDIR)/debian/tmp go generate -x ./internal/i18n ./cmd/aad-cli

## aad-auth 0.5.2

=== debian/changelog ===
aad-auth (0.5.2) mantic; urgency=medium

  * Update Go version to 1.21
    - This is not a new feature breakage. The previous build introduced
      a new symbol required by golang-go-1.21, so we need to bump the
      minimal required Go version to 1.21.
  * Update MSAL version to 1.2.0
  * Update dependencies to latest:
    ** Rust
      - cc
      - libnss
      - time
    ** Go
      - golang.org/x/sys
  * Clean up some packaging steps
    - Some workarounds were necessary due to unmerged upstream changes. Now
      the fixes are merged and released, so packaging could be cleaned up.
  * Update CI dependencies not related to package functionality:
    - github.com/golangci/golangci-lint

 -- Denison Barbosa <denison.barbosa@canonical.com>  Thu, 24 Aug 2023 06:03:22 -0400

aad-auth (0.5.1) mantic; urgency=medium

  * Fix FTBFS due to missing new required symbol

 -- Denison Barbosa <denison.barbosa@canonical.com>  Fri, 18 Aug 2023 06:24:12 -0400

aad-auth (0.5) mantic; urgency=medium

  * New release (LP: #2031534)
  * Update Go version to 1.20
  * Update MSAL version to 1.1
  * Specify default scopes for authentication
    - After MSAL 1.0, the API no longer provides a set of default scopes in
      case none was specified. So now we specify the authentication scopes
      manually.
  * Normalize names used in NSS queries
    - Lowercase the names used in all queries to account for the case
      insensitivity of AAD.
  * Consider effective UID/GID when evaluating access to Shadow database:
    - This fixes the issue where AAD users could not open sudo sessions, even
      though they were part of the sudo group
  * Improved errors messages
    - Show link(s) to error code(s) description on Microsoft's site
  * Update dependencies to latest:
    ** Go
      - github.com/mattn/go-sqlite3
      - github.com/sirupsen/logrus
      - github.com/spf13/cobra
      - github.com/stretchr/testify
      - golang.org/x/crypto
      - golang.org/x/sys
    ** Rust
      - cc
      - ctor
      - goldenfile
      - libc
      - log
      - paste
      - proc-macro2
      - rusqlite
      - serde
      - serde_yaml
      - simple_logger
      - syslog
      - tempfile
      - test-case
      - time
  * Update CI dependencies not related to package functionality:
    - github.com/golangci/golangci-lint
    - actions/setup-go
    - peter-evans/create-pull-request

 -- Denison Barbosa <denison.barbosa@canonical.com>  Mon, 14 Aug 2023 09:48:57 -0400

=== debian/control ===
Source: aad-auth
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 13),
               dh-apport,
               dh-cargo,
               dh-golang,
               golang-go (>= 2:1.21~),
               libpam0g-dev (>= 1.4),
               libc6-dev (>= 2.35),
               libglib2.0-dev (>= 2.72.1),
               pkg-config (>= 0.29.2),
               libsqlite3-dev (>= 3.37.2)
Standards-Version: 4.6.0.1
XS-Go-Import-Path: github.com/ubuntu/aad-auth
XS-Vendored-Sources-Rust: ahash@0.7.6, autocfg@1.1.0, bitflags@1.3.2, bitflags@2.0.2, bstr@0.2.17, cc@1.0.83, cfg-if@1.0.0, console@0.15.5, ctor@0.2.4, deranged@0.3.7, encode_unicode@0.3.6, equivalent@1.0.0, errno-dragonfly@0.1.2, errno@0.3.1, error-chain@0.12.4, faccess@0.2.4, fallible-iterator@0.2.0, fallible-streaming-iterator@0.1.9, fastrand@1.8.0, getrandom@0.2.8, goldenfile@1.5.2, hashbrown@0.12.3, hashbrown@0.14.0, hashlink@0.8.1, hermit-abi@0.3.1, hostname@0.3.1, indexmap@2.0.0, instant@0.1.12, io-lifetimes@1.0.11, itoa@1.0.5, lazy_static@1.4.0, libc@0.2.147, libnss@0.5.0, libsqlite3-sys@0.26.0, linux-raw-sys@0.3.8, log@0.4.20, match_cfg@0.1.0, memchr@2.5.0, num_threads@0.1.6, once_cell@1.17.0, paste@1.0.14, pkg-config@0.3.26, proc-macro-error-attr@1.0.4, proc-macro-error@1.0.4, proc-macro2@1.0.66, quote@1.0.33, redox_syscall@0.3.5, regex-automata@0.1.10, rusqlite@0.29.0, rustix@0.37.19, ryu@1.0.12, serde@1.0.188, serde_derive@1.0.188, serde_yaml@0.9.25, similar-asserts@1.4.2, similar@2.2.1, simple_logger@4.2.0, smallvec@1.10.0, syn@1.0.107, syn@2.0.29, syslog@6.1.0, tempfile@3.6.0, test-case-core@3.0.0, test-case-macros@3.0.0, test-case@3.1.0, time-core@0.1.1, time-macros@0.2.14, time@0.3.28, unicode-ident@1.0.6, unicode-segmentation@1.10.1, unsafe-libyaml@0.2.7, users@0.11.0, vcpkg@0.2.15, version_check@0.9.4, wasi@0.11.0+wasi-snapshot-preview1, winapi-i686-pc-windows-gnu@0.4.0, winapi-x86_64-pc-windows-gnu@0.4.0, winapi@0.3.9, windows-sys@0.42.0, windows-sys@0.48.0, windows-targets@0.48.0, windows_aarch64_gnullvm@0.42.1, windows_aarch64_gnullvm@0.48.0, windows_aarch64_msvc@0.42.1, windows_aarch64_msvc@0.48.0, windows_i686_gnu@0.42.1, windows_i686_gnu@0.48.0, windows_i686_msvc@0.42.1, windows_i686_msvc@0.48.0, windows_x86_64_gnu@0.42.1, windows_x86_64_gnu@0.48.0, windows_x86_64_gnullvm@0.42.1, windows_x86_64_gnullvm@0.48.0, windows_x86_64_msvc@0.42.1, windows_x86_64_msvc@0.48.0
Homepage: https://github.com/ubuntu/aad-auth
Description: Azure Active Directory Authentication
 Azure Active Directory Authentication enables authentication of Azure Active
 Directory accounts on your local system. It dynamically creates local accounts,
 supporting additional features like offline connectivity.


Package: libpam-aad
Architecture: any
Built-Using: ${misc:Built-Using},
Depends: aad-common,
         ${shlibs:Depends},
         ${misc:Depends},
Description: ${source:Synopsis} module for PAM
 ${source:Extended-Description}
 .
 This package contains the PAM module.

Package: libnss-aad
Architecture: any
Multi-Arch: same
Built-Using: ${misc:Built-Using},
Depends: aad-common,
         ${shlibs:Depends},
         ${misc:Depends},
Description: ${source:Synopsis} module for NSS
 ${source:Extended-Description}
 .
 This package contains the NSS module.

Package: aad-common
Architecture: all
Multi-Arch: foreign
Enhances: libpam-aad, libnss-aad, aad-cli
Depends: ${misc:Depends}
Description: ${source:Synopsis} common files
 ${source:Extended-Description}
 .
 This package contains configuration and translation files shared between the
 other AAD packages.

Package: aad-cli
Architecture: any
Built-Using: ${misc:Built-Using},
Depends: aad-common,
         ${shlibs:Depends},
         ${misc:Depends},
Description: ${source:Synopsis} CLI tool
 ${source:Extended-Description}
 .
 This package contains the CLI tool to manage various aspects of the Azure AD
 integration.

=== debian/rules ===
--- 
+++ 
@@ -32,12 +32,24 @@
 	# Create the vendor directory when building the source package
 	[ -d vendor/ ] || go mod vendor
 
-	# vcpkg has the same issue as system-deps, with .a files that are trimmed by dpkg-source.
-	# so we need to replace the crate checksum to avoid build errors.
+	# Some crates are shipped with .a files, which get removed by the helpers during the package build as a safety measure.
+	# This results in cargo failing to compile, since the files (which are listed in the checksums) are not there anymore.
+	# For those crates, we need to replace their checksum with a more general one that only lists the crate checksum, instead of each file.
 	if [ ! -d $(CARGO_VENDOR_DIR)/ ]; then \
 		$(CARGO) vendor $(CARGO_VENDOR_DIR); \
-		cp debian/cargo-checksum.json $(CARGO_VENDOR_DIR)/vcpkg/.cargo-checksum.json; \
 		[ ! -e $(DH_CARGO_VENDORED_SOURCES) ] || $(DH_CARGO_VENDORED_SOURCES); \
+		\
+		[ -e /usr/bin/jq ] || (echo "jq is required to run this script. Try installing it with 'sudo apt install jq'" && exit 1); \
+		\
+		for dep in $$(ls vendor_rust -1); do \
+			checksum_file="vendor_rust/$${dep}/.cargo-checksum.json"; \
+			a_files=$$(cat $${checksum_file} | jq '.files | keys | map(select(.|test(".a$$")))'); \
+			if [ "$$a_files" = "[]" ]; then \
+				continue; \
+			fi; \
+			pkg_checksum=$$(cat "$${checksum_file}" | jq '.package'); \
+			echo "{\"files\": {}, \"package\": $${pkg_checksum}}" >"$${checksum_file}"; \
+		done; \
 	fi
 
 override_dh_auto_configure:
@@ -46,10 +58,8 @@
 	[ ! -e $(DH_CARGO_VENDORED_SOURCES) ] || $(DH_CARGO_VENDORED_SOURCES)
 	DEB_HOST_GNU_TYPE=$(DEB_HOST_GNU_TYPE) DEB_HOST_RUST_TYPE=$(DEB_HOST_RUST_TYPE) \
 		CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=nss_aad_$(shell dpkg-parsechangelog --show-field Version) \
+		RUSTFLAGS="--cfg=rustix_use_libc" \
 		$(CARGO) prepare-debian $(CARGO_VENDOR_DIR)
-
-	# By default, dh-cargo only replaces the crates-io source, which means we have to replace the git source manually
-	cat debian/cargo-config-patch >> $(CURDIR)/debian/cargo_home/config
 
 override_dh_auto_build:
 	# Build PAM library

=== debian/tests/control ===
Test-Command: go test -v -mod=vendor ./...
Restrictions: allow-stderr
Depends: @builddeps@

## aad-auth 0.5.2build1

=== debian/changelog ===
aad-auth (0.5.2build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:40:02 +0200

## aad-auth 0.5.2ubuntu0.1

=== debian/changelog ===
aad-auth (0.5.2ubuntu0.1) mantic-security; urgency=medium

  * No change rebuild due to golang-1.20, golang-1.21 updates

 -- Nishit Majithia <nishit.majithia@canonical.com>  Thu, 01 Feb 2024 13:24:14 +0530
